package com.example.vocab.basic

import java.util.*

open class Word(val id: String, val from: String, val to: String = "", val list: String = "", val language: String = "", val class_id: String = "", val newList: Boolean = false,
                val _stats: WordStats = WordStats()): Syncable{
    open class WordStats(_numFail: Int = 0, _numSucces: Int = 0,
                          _lastTested: Date = Date()
    ){
        open var numFail = _numFail
            protected set
        open var numSucces = _numSucces
            protected set
        open var lastTested = _lastTested
            protected set
    }

    open var stats = _stats
        protected set

    fun copy(from: String = this.from, to: String = this.to, list: String = this.list, language: String = this.language, class_id: String = this.class_id, id: String = this.id,
        newList: Boolean = this.newList, _stats: WordStats = this.stats): Word{
        return Word(id, from, to, list, language, class_id, newList, _stats)
    }

    override fun getID(): String{
        return id
    }

    override fun getType(): Syncable.Types {
        return Syncable.Types.Vocabulary
    }
}