package com.example.vocab.setting

import android.view.View
import com.example.vocab.databinding.FragmentLanguageCellBinding
import com.example.vocab.gui.BaseItem
import com.example.vocab.R

data class BaseLanguageCell(private val name: String): BaseItem<FragmentLanguageCellBinding> {
    class OnClickListener(private val func: (lan: String)->Unit){
        fun onClick(lan: String){
            func(lan)
        }
    }

    override val layoutId: Int = R.layout.fragment_language_cell
    override val itemID: Any = name

    var onClick: OnClickListener? = null

    override fun initViewBinding(view: View): FragmentLanguageCellBinding {
        return FragmentLanguageCellBinding.bind(view)
    }

    override fun getBinding(binding: FragmentLanguageCellBinding) {
        binding.language = name

        onClick?.let{
            binding.clickListener = onClick
        }
    }
}